const {Client, GatewayIntentBits,Partials, AtivityType} = require('./lib.js');
const mongoose = require('mongoose');
const mongoDB = process.env.mongoDB;

const bot = new Client(
    {
        intents: 
        [
            GatewayIntentBits.Guilds,  
            GatewayIntentBits.GuildMembers,
            GatewayIntentBits.GuildBans,
            GatewayIntentBits.GuildEmojisAndStickers,
            GatewayIntentBits.GuildIntegrations ,
            GatewayIntentBits.GuildWebhooks ,
            GatewayIntentBits.GuildInvites ,
            GatewayIntentBits.GuildVoiceStates,
            GatewayIntentBits.GuildPresences,
            GatewayIntentBits.GuildMessages,
            GatewayIntentBits.GuildMessageReactions,
            GatewayIntentBits.GuildMessageTyping,
            GatewayIntentBits.DirectMessages,
            GatewayIntentBits.DirectMessageReactions,
            GatewayIntentBits.DirectMessageTyping,
            GatewayIntentBits.MessageContent,
            GatewayIntentBits.GuildScheduledEvents,
            GatewayIntentBits.AutoModerationConfiguration,
            GatewayIntentBits.AutoModerationExecution
        ],
        partials: 
        [
            Partials.Reaction,
            Partials.Message 
        ]
    }
)
bot.login(process.env.discord_token);
bot.on('ready', ()=>
{
    mongoose.Promise = global.Promise;
    mongoose.connect(mongoDB).catch(err=>console.log(err));
    console.log('Ready');
});